=== modified file 'io/readraw.cxx'
--- io/readraw.cxx	2004-08-03 14:05:14 +0000
+++ io/readraw.cxx	2007-11-19 15:32:51 +0000
@@ -59,6 +59,7 @@
 #include "machine.hxx" // portability stuff
 #include "rawImage.hxx"
 #include "readraw.hxx"
+#include "byte-swap.h"
 
 using std::map;
 
@@ -181,7 +182,7 @@
 	  case IM_FLOAT:
 	  {
 	      float **flt_buf;
-
+	     
 	      retval = readrawbuf(rfd, myheader, flt_buf);
 	      buffp = (void **)flt_buf;
 	  }
@@ -219,7 +220,8 @@
     int                i, j, p, l, interleave;
     ssize_t            nbread = 0;
     int                retval = 0;
-        
+    bool               swap = false;
+   
      
     nx = myheader.nx;
     ny = myheader.ny;
@@ -335,6 +337,33 @@
 	
     }
 
+    if(myheader.byo == 1) { // MSB
+#ifndef TARGET_BIG_ENDIAN_DEFAULT
+       swap = true;
+#endif       
+    } else if(myheader.byo == 2) { //LSB
+#ifdef TARGET_BIG_ENDIAN_DEFAULT
+       swap = true;
+#endif              
+    }
+
+    if(swap) {
+       switch(sizeof(T)) {
+	 case 2:
+	  for(j = 0; j < spp; j++) 
+	      swap_2_bytes((void *) cbuf[j], nx*ny*nz);
+	  break;
+	 case 4:
+	  for(j = 0; j < spp; j++)
+	      swap_4_bytes((void *) cbuf[j], nx*ny*nz);
+	  break;
+	 case 8:
+	  for(j = 0; j < spp; j++) 
+	      swap_8_bytes((void *) cbuf[j], nx*ny*nz);
+	  break;
+       }
+    }
+
     buffp = cbuf;
     
     return retval;

=== modified file 'rawImage.cxx'
--- rawImage.cxx	2003-12-25 03:15:57 +0000
+++ rawImage.cxx	2007-11-19 15:32:51 +0000
@@ -46,6 +46,7 @@
 #include "imnmspc.hxx"
 
 #include <stdio.h>
+#include <string.h>
 #include <assert.h>
 #include <time.h>
 #include <sys/stat.h>
@@ -76,6 +77,12 @@
     return;
 }
 
+void rawimage::setFileName(const char *v) 
+{
+   strncpy(filename, v, 1023);
+}
+
+
 void rawimage::setDefaults(void)
 {
     // explanatory text
@@ -102,7 +109,7 @@
     dataSize = headerSize = 0;
     
     dataSize = 0;
-    filename = 0; 
+    filename[0] = '\0';
 }
 
 void rawimage::show()

=== modified file 'rawImage.hxx'
--- rawImage.hxx	2003-12-25 03:15:57 +0000
+++ rawImage.hxx	2007-11-19 15:32:51 +0000
@@ -82,9 +82,8 @@
     // this method saves the user input
     void saveHeader(void);
     void tryReading(void);
-    // very important
-    void setFileName(const char *v) { filename = v; }
-    
+    void setFileName(const char *v);
+
     friend Fl_Window *rawimage_panel(rawimage &ri);
 
     enum {Uchar = 0, Short, Ushort, Int, Uint, Long, Ulong, Float, Double};
@@ -120,7 +119,7 @@
     int               interleave;
     int               byteOrder;
     pixtype           ptype;
-    const char       *filename;
+    char	      filename[1024];
 
     void              recomputeHeader(void);
     int               computeSkip(void);

